/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

#include "play.h"

void show_password(int);
void replay(field *);
void come_back_one_step(field *, int);

void play(field *stage)
{

    int with_box, allowed_to_come_back_one_step;
    with_box = allowed_to_come_back_one_step = 0;

	do
	{
        //clear_keybuf();
        rest(10);
		readkey();

        if(key[KEY_P])
            break;

        if( key[KEY_B] && (allowed_to_come_back_one_step == 1) )
        {
            come_back_one_step(stage, with_box);
            allowed_to_come_back_one_step = 0;
        }

        if(key[KEY_R])
        {
            unload_stage(stage);
            stage = load_stage(int_to_string(stage->level), stage);
            replay(stage);
        }

        if(key[KEY_V])
        {
            unload_stage(stage);
            stage = load_stage(int_to_string(stage->level), stage);
            destroy_list(stage->list_of_steps);
            stage->list_of_steps = build_list();
            player[12]=player[0];
            play(stage);
        } 


		if( key[KEY_UP] && allowed_move(stage, 0, -1) )
		{
            store_list(stage->list_of_steps, UP);
	        player[12]=player[1+step];
            with_box =  which_animation(stage, 0 , -1);
            move_player (stage, 0, -1);
            print_game (stage, UP, with_box);
            allowed_to_come_back_one_step = 1;
		}

		if( key[KEY_RIGHT] && allowed_move(stage, 1, 0) )
		{
            store_list(stage->list_of_steps, RIGHT);
		   	player[12]=player[4+step];
            with_box =  which_animation(stage, 1 , 0);
            move_player (stage, 1, 0);
            print_game (stage, RIGHT, with_box);
            allowed_to_come_back_one_step = 1;
		}

		if( key[KEY_DOWN] && allowed_move(stage, 0, 1) )
		{
            store_list(stage->list_of_steps, DOWN);
  			player[12]=player[7+step];
            with_box =  which_animation(stage, 0 , 1);
            move_player (stage, 0, 1);
            print_game (stage, DOWN, with_box);
            allowed_to_come_back_one_step = 1;
		}

		if( key[KEY_LEFT] && allowed_move(stage, -1, 0) )
		{
            store_list(stage->list_of_steps, LEFT);
		    player[12]=player[10+step];
            with_box =  which_animation(stage, -1, 0);
            move_player (stage, -1, 0);
            print_game (stage, LEFT, with_box);
            allowed_to_come_back_one_step = 1;
		}

		if( key[KEY_ESC]  ){unload_stage (stage); free (stage); finish_game();}

	} while ( all_boxes_placed(stage) != 1 );


	unload_stage (stage);
	stage->level++;
    
   	congratulations();
    if( ((stage->level-1)%10 == 0) && (stage->level != 1) )
        show_password(stage->level);

   	stage = load_stage (int_to_string(stage->level), stage);
    destroy_list(stage->list_of_steps);
    stage->list_of_steps = build_list();


	play (stage);

}

/*-------------------------------------------------------------------------------------------------------------------*/

void replay(field *stage)
{

    int direction;
    int with_box;
    node *n;

    list *temp = build_list();;

    n = stage->list_of_steps->first;

    do
	{
	    //clear_keybuf();
	    rest(10);
		readkey();
	
	    if(key[KEY_P])
	        break;
	
	    if(key[KEY_R])
	    {
	        unload_stage(stage);
	        stage = load_stage(int_to_string(stage->level), stage);
	        replay(stage);
	    }

	    if (key[KEY_UP] || key[KEY_RIGHT] || key[KEY_DOWN] || key[KEY_LEFT])
        {
			if( key[KEY_UP] )
				if ( allowed_move(stage, 0, -1) )
				{
	                store_list(temp, UP);
		    		player[12]=player[1+step];
	                with_box =  which_animation(stage, 0 , -1);
	                move_player (stage, 0, -1);
	                print_game (stage, UP, with_box);
				}
	
			if( key[KEY_RIGHT] )
				if ( allowed_move(stage, 1, 0) )
				{
	                store_list(temp, RIGHT);
			    	player[12]=player[4+step];
	                with_box =  which_animation(stage, 1 , 0);
	                move_player (stage, 1, 0);
	                print_game (stage, RIGHT, with_box);
				}
	
			if( key[KEY_DOWN] )
				if ( allowed_move(stage, 0, 1) )
				{
	                store_list(temp, DOWN);
	    			player[12]=player[7+step];
	                with_box =  which_animation(stage, 0 , 1);
	                move_player (stage, 0, 1);
	                print_game (stage, DOWN, with_box);
				}
	
			if( key[KEY_LEFT] )
				if ( allowed_move(stage, -1, 0) )
				{
	                store_list(temp, LEFT);
				    player[12]=player[10+step];
	                with_box =  which_animation(stage, -1, 0);
	                move_player (stage, -1, 0);
	                print_game (stage, LEFT, with_box);
				}

            destroy_list(stage->list_of_steps);
            stage->list_of_steps = temp;
            play(stage);
        }

	    if (key[KEY_N])
	    {
	        if(n != NULL)
	        {
	            direction = n->direction;
	            n = n->next;
	        }
            else
            {
                destroy_list(stage->list_of_steps);
                stage->list_of_steps = temp;
                play(stage);
            }
	    }

		
		if( direction == UP )
		{
            store_list(temp, UP);
			player[12]=player[1+step];
            with_box =  which_animation(stage, 0 , -1);
            move_player (stage, 0, -1);
            print_game (stage, UP, with_box);
        }
	
		if( direction == RIGHT )
		{
            store_list(temp, RIGHT);
			player[12]=player[4+step];
            with_box =  which_animation(stage, 1 , 0);
            move_player (stage, 1, 0);
            print_game (stage, RIGHT, with_box);
		}
	
		if( direction == DOWN )
		{
            store_list(temp, DOWN);
			player[12]=player[7+step];
            with_box =  which_animation(stage, 0 , 1);
            move_player (stage, 0, 1);
            print_game (stage, DOWN, with_box);
		}

		if( direction == LEFT )
		{
            store_list(temp, LEFT);
			player[12]=player[10+step];
            with_box =  which_animation(stage, -1, 0);
            move_player (stage, -1, 0);
            print_game (stage, LEFT, with_box);
    	}
            
        direction = -1;
    	if( key[KEY_ESC]  ){unload_stage (stage); free (stage); finish_game();}

	} while ( all_boxes_placed(stage) != 1 );


	unload_stage (stage);
    destroy_list(stage->list_of_steps);
	stage->level++;
    
   	congratulations();
   	stage = load_stage (int_to_string(stage->level), stage);
    stage->list_of_steps = build_list();

	play (stage);

}

/*-------------------------------------------------------------------------------------------------------------------*/


void come_back_one_step(field *stage, int with_box)
{
    int direction;
    
    direction = stage->list_of_steps->last->direction;


			if( direction == UP )
			{
				player[12]=player[1+step];
	            move_player (stage, 0, 1);
                if(with_box == 1)
                {
                    stage->field[stage->player.x-2][stage->player.y] = FREE_SPACE;
                    stage->field[stage->player.x-1][stage->player.y] = BOX;
                }    
	            reprint_game (stage, UP, with_box);
	        }
	
			if( direction == RIGHT )
			{
				player[12]=player[4+step];
	            move_player (stage, -1, 0);
                if(with_box == 1)
                {
                    stage->field[stage->player.x][stage->player.y+2] = FREE_SPACE;
                    stage->field[stage->player.x][stage->player.y+1] = BOX;
                }    
	            reprint_game (stage, RIGHT, with_box);
			}
	
			if( direction == DOWN )
			{
				player[12]=player[7+step];
	            move_player (stage, 0, -1);
                if(with_box == 1)
                {
                    stage->field[stage->player.x+2][stage->player.y] = FREE_SPACE;
                    stage->field[stage->player.x+1][stage->player.y] = BOX;
                }    
	            reprint_game (stage, DOWN, with_box);
			}
	
			if( direction == LEFT )
			{
				player[12]=player[10+step];
	            move_player (stage, 1, 0);
                if(with_box == 1)
                {
                    stage->field[stage->player.x][stage->player.y-2] = FREE_SPACE;
                    stage->field[stage->player.x][stage->player.y-1] = BOX;
                }    
	            reprint_game (stage, LEFT, with_box);
			}

        remove_last_node(stage->list_of_steps);

        play(stage);
}
